#<profile4xi profile = "02" />
# -------------------------------------------------------------------------------------------------
#<program4xi program = "valueproxy4xi.py">
#<abstract4xi abstract = "provides class ValueProxy4Xi"/>
#<refer4xi reference = "managers.py"/> 
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'ValueProxy4Xi' ]
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import weakref
import array
import queue
from traceback import format_exc
import copyreg
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
try:
    from multiprocessing import managers
except:
    print("valueproxy4xi.py *** failed in from multiprocessing import managers ***") 
try:
    from multiprocessing.managers import ValueProxy
except:
    print("valueproxy4xi.py *** failed in multiprocessing.managers import ValueProxy ***")         
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from ace_object4xi import ace_object4xi
from baseproxy4xi import BaseProxy4Xi
from print4xi import print4xi
from reason_object4xi import reason_object4xi
from sense_object4xi import sense_object4xi
from time4xi import time4xi
#"
#/>


#
# =================================================================================================
#<class4xi class = "ValueProxy4Xi" base = "BaseProxy4Xi" child = "None" synopsis = "BaseProxy4Xi" usage = "
#   managers.py                              
#       SyncManager.register('Value', Value, ValueProxy)
#
#   syncmanager4xi.py:
#       SyncManager4Xi.register('Value4Xi', Value4Xi, ValueProxy4Xi)"
#>
#<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# =================================================================================================
class ValueProxy4Xi(BaseProxy4Xi): 
    '''
    ValueProxy4Xi class: given in managers as a parameter to SyncManager
    '''
  
    # ---------------------------------------------------------------------------------------------
    # Public API of this class
    # ---------------------------------------------------------------------------------------------    
    #<expose4xi expose = "
    _exposed_ = ('get',
                 'set',
                 'sense',
                 'reason',
                 'ace')          
    #"
    #/>

                                                       
                                          
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "get-of-ValueProxy4Xi" usage = "gets self._callmethod">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------    
    def get(self):
        '''
        ValueProxy4Xi method gets self._callmethod
        '''
        
        # -------------------------------------------------------------------------------------    
        #
        # -------------------------------------------------------------------------------------  
          
        class2print = "ValueProxy4Xi"
        method2print = "get"
        
        
        message2print = "{started" + "; get-of-ValueProxy4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
           
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------                 
        message2print = "{passing" + "; get-passing-to-callmethod-function-of-valueproxy2xi-by-get-of-ValueProxy4Xi: " + str('get') + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            

        message2print = "{returning" + "; callmethod-function-of-valueproxy2xi-returning-by-get-of-ValueProxy4Xi: " + str(self._callmethod) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)  
                          
        
        return self._callmethod('get')
    #</methodize4xi>
            
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "set-of-ValueProxy4Xi" usage = "sets self._callmethod ">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------    
    def set(self, value):
        '''
        ValueProxy4Xi method sets self._callmethod 
        '''
        
        # -------------------------------------------------------------------------------------    
        #
        # -------------------------------------------------------------------------------------  

        class2print = "ValueProxy4Xi"
        method2print = "set"
        
        message2print = "{started" + "; set-of-ValueProxy4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
             
        message2print = "{passed" + "; value-passed-to-set-of-ValueProxy4Xi: " + str(value) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
        
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------                 
        message2print = "{passing" + "; set-passing-to-callmethod-function-of-valueproxy2xi-by-set-of-ValueProxy4Xi: " + str('set') + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
                        
        message2print = "{passing" + "; value-passing-to-callmethod-function-of-valueproxy2xi-by-set-of-ValueProxy4Xi: " + str(value) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                 
        
        message2print = "{returning" + "; callmethod-function-of-valueproxy2xi-returning-by-set-of-ValueProxy4Xi: " + str(self._callmethod) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)  
                        
        
        return self._callmethod('set', (value,))       
    #</methodize4xi>
    
    #                                        
    # ---------------------------------------------------------------------------------------------
    # sharable class variables
    #<note4xi note = "class variable value is defined here because it uses methods get and set"/>
    # ---------------------------------------------------------------------------------------------      
    #<share4xi share = " 
    value = property(get, set)
    #"
    #/>
                                           
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "sense-of-ValueProxy4Xi" usage = "senses ValueProxy4Xi class objects">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def sense(self):
        '''
        method sense: senses ValueProxy4Xi class objects
        '''
        
        # -------------------------------------------------------------------------------------    
        #
        # -------------------------------------------------------------------------------------  
        class2print = 'ValueProxy4Xi'
        method2print = 'sense'
        
        message2print = "{started" + "; sense-of-ValueProxy4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
            

        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------  
        message2print = "{sensing" + "; ValueProxy4Xi-sensing-by-sense-of-ValueProxy4Xi: " + str(ValueProxy4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
                                     
        
        # -----------------------------------------------------------------------------------------
        # get sensed knowledge for this object
        # -----------------------------------------------------------------------------------------        
        kb2xi = sense_object4xi(self)
        
        message2print = "{got" + "; kb2xi-got-by-sense-of-ValueProxy4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # -----------------------------------------------------------------------------------------         
        try:
            kb2xi['inheritance-of-value2xi'] = BaseProxy4Xi
        except:
            message2print = "{yielded" + "; kb2xi-yielded-by-sense-of-ValueProxy4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            
        
        
      
        message2print = "{sensed" + "; ValueProxy4Xi-sensed-by-sense-of-ValueProxy4Xi: " + str(ValueProxy4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        
        # -----------------------------------------------------------------------------------------
        # 
        # -----------------------------------------------------------------------------------------         
        message2print = "{returning" + "; kb2xi-returning-by-sense-of-ValueProxy4Xi: " + str(kb2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
                                 
          
        return kb2xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
    #</methodize4xi>
    
        
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "reason-of-ValueProxy4Xi" usage = "reasons ValueProxy4Xi class objects">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def reason(self):
        '''
        method reason: reasons ValueProxy4Xi class objects
        '''
        
        # -------------------------------------------------------------------------------------    
        #
        # -------------------------------------------------------------------------------------  

        class2print = 'ValueProxy4Xi'
        method2print = 'reason'
        
        message2print = "{started" + "; reason-of-ValueProxy4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
    
      
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        message2print = "{reasoning" + "; ValueProxy4Xi-reasoning-by-reason-of-ValueProxy4Xi: " + str(ValueProxy4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
                
        
        # -----------------------------------------------------------------------------------------
        # get reasoned knowledge for this object
        # -----------------------------------------------------------------------------------------         
        kb4xi = reason_object4xi(self)
        
        message2print = "{got" + "; kb4xi-got-by-reason-of-ValueProxy4Xi: " + str(kb4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb4xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------          
        
        
          
        
        message2print = "{reasoned" + "; ValueProxy4Xi-reasoned-by-reason-of-ValueProxy4Xi: " + str(ValueProxy4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        message2print = "{returning" + "; kb4xi-returning-by-reason-of-ValueProxy4Xi: " + str(kb4xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
                                
          
        return kb4xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
    
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "ace-of-ValueProxy4Xi" usage = "aces ValueProxy4Xi class objects">
    #<state4xi status = "ACK4review; ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
    # ---------------------------------------------------------------------------------------------
    def ace(self):
        '''
        method ace: aces ValueProxy4Xi class objects 
        '''
        
        # -------------------------------------------------------------------------------------    
        #
        # -------------------------------------------------------------------------------------  
        class2print = 'ValueProxy4Xi'
        method2print = 'ace'
        
        
        message2print = "{started" + "; ace-of-ValueProxy4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
              
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        message2print = "{acing" + "; ValueProxy4Xi-acing-by-ace-of-ValueProxy4Xi: " + str(ValueProxy4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
                 
        
        # -----------------------------------------------------------------------------------------
        # get aced knowledge for this object
        # -----------------------------------------------------------------------------------------        
        kb8xi = ace_object4xi(self)  
        
        message2print = "{got" + "; kb8xi-got-by-ace-of-ValueProxy4Xi: " + str(kb8xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                


        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb8xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------              
        
          
        message2print = "{aced" + "; ValueProxy4Xi-aced-by-ace-of-ValueProxy4Xi: " + str(ValueProxy4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)       
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        message2print = "{returning" + "; kb8xi-returning-by-ace-of-ValueProxy4Xi: " + str(kb8xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
                               
        
        return kb8xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
#</class4xi>
#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   None
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 
#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of valueproxy4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>


